/**
 * @module events__channels
 */

modules.define('events__channels', ['events'], function(provide, events) {

var undef,

/**
 * Communication channels storage
 * @type Object
 */
    channels = {};

/**
 * Returns/destroys a named communication channel
 * @param {String} [id='default'] Channel ID
 * @param {Boolean} [drop=false] Destroy the channel
 * @returns {events.Emitter|undefined} Communication channel
 */
provide(function(id, drop) {
    if(typeof id === 'boolean') {
        drop = id;
        id = undef;
    }

    id || (id = 'default');

    if(drop) {
        if(channels[id]) {
            channels[id].un();
            delete channels[id];
        }
        return;
    }

    return channels[id] || (channels[id] = new events.Emitter());
});

});